﻿if(typeof linkchecker == "undefined")
	var linkchecker = {};
if(typeof linkchecker.drweb == "undefined")
	linkchecker.drweb = {};
if(typeof linkchecker.drweb.com == "undefined")
	linkchecker.drweb.com = {};


linkchecker.drweb.com = new function()
{
	var self = this;
	this.Locale	=	Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://linkcheker/locale/linkchecker.properties");

	this.Startup = function()
	{
		this.LinkInTextRegexp	=	/(https?:\/\/|ftp:\/\/)?(?:_*?)((?:[a-z0-9-.]+|[а-я0-9-.]+)\.(?:museum|aero|biz|coop|info|name|com|edu|int|net|org|ru|ac|ad|ae|af|ag|ai|al|am|an|ao|aq|ar|as|at|au|aw|az|ba|bb|bd|be|bf|bg|bh|bi|bj|bm|bn|bo|br|bs|bt|bv|bw|by|bz|ca|cc|cd|cf|cg|ch|ci|ck|cl|cm|cn|co|cr|cu|cv|cx|cy|cz|de|dj|dk|dm|do|dz|ec|ee|eg|eh|er|es|et|eu|eu|fi|fj|fk|fm|fo|fr|ga|gb|gd|ge|gf|gg|gh|gi|gl|gm|gn|gov|gp|gq|gr|gs|gt|gu|gw|gy|hk|hm|hn|hr|ht|hu|id|ie|il|im|in|io|iq|ir|is|it|je|jm|jo|jp|ke|kg|kh|ki|km|kn|kp|kr|kw|ky|kz|la|lb|lc|li|lk|lr|ls|lt|lu|lv|ly|ma|mc|md|mg|mh|mil|mk|ml|mm|mn|mo|mp|mq|mr|ms|mt|mu|mv|mw|mx|my|mz|na|nc|ne|nf|ng|ni|nl|no|np|nr|nu|nz|om|pa|pe|pf|pg|ph|pk|pl|pm|pn|pr|ps|pt|pw|py|qa|re|ro|rw|sa|sb|sc|sd|se|sg|sh|si|sj|sk|sl|sm|sn|so|sr|st|su|sv|sy|sz|tc|td|tf|tg|th|tj|tk|tm|tn|to|tp|tr|tt|tv|tw|tz|ua|ug|uk|um|us|uy|uz|va|vc|ve|vg|vi|vn|vu|wf|ws|ye|yt|yu|za|zm|zw|рф|xn--[^\/]+)(?:\/[^\s]+|\/?))/i;
		this.LinkHrefRegexp	=	/^(https?:\/\/|ftp:\/\/)?(.+\.[^\.\/]+(?:\/.+$|\/$|$))/i;
	}

	this.ScanLink = function() {

		// scan links for thunderbirds

		if (!gContextMenu) {
			return;
		}

		var isLink = false;
		var selectedText = document.commandDispatcher.focusedWindow.getSelection().toString();

		if (!selectedText) {
			selectedText = gContextMenu.getLinkURL();
			isLink = true;
		}

		var result = isLink? LinkHrefRegexp.exec(selectedText) : LinkInTextRegexp.exec(selectedText);
		if (result) {
			var url = (result[1]? result[1] : 'http://') + result[2];
			var targetURL = result[2];

			var href = "http://online.drweb.com/result/?thunderbirdplugin=1&url=" + encodeURIComponent(url);
			var frame = '<iframe src="' + href + '" style="width: 640px; height: 400px; border: none; margin: 0 auto;" id="cheker-answer"></iframe>';

			var ww = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);

			var newWnd = ww.openWindow(null, "about:blank", 'Scanlink '+ targetURL, "chrome,centerscreen,width=655,height=416,scrollbars=no,resizable=no", null);

			newWnd.onload = function() {

				// use frame to get info from drweb checker service
				newWnd.document.body.innerHTML += frame;

				newWnd.document.getElementById('cheker-answer').addEventListener("DOMContentLoaded", function() {
					newWnd.document.title = self.Locale.GetStringFromName('scanResult');

					newWnd.document.getElementById('cheker-answer').addEventListener("click", function(eventObj) {
						if(eventObj.target.nodeName == 'IMG' && eventObj.target.src.indexOf('closed') != -1)
						{
							newWnd.close();
							eventObj.preventDefault();
							eventObj.stopPropagation();
							return true;
						}

						if((eventObj.target.nodeName == 'A' && eventObj.target.href) || (typeof eventObj.target.parentNode != "undefined" && eventObj.target.parentNode.nodeName == 'A' && eventObj.target.parentNode.href))
						{
							var href = typeof eventObj.target.href != "undefined"? eventObj.target.href : eventObj.target.parentNode.href;
							var ioservice = Components.classes["@mozilla.org/network/io-service;1"]
													  .getService(Components.interfaces.nsIIOService);
							var uriToOpen = ioservice.newURI(href, null, null);
							var extps = Components.classes["@mozilla.org/uriloader/external-protocol-service;1"]
												  .getService(Components.interfaces.nsIExternalProtocolService);
							extps.loadURI(uriToOpen, null);
							eventObj.preventDefault();
							eventObj.stopPropagation();
							return true;
						}
					}, true);

				}, true);

				newWnd.document.title = self.Locale.GetStringFromName('scanning')+'...';
			};

			return true;
		}
		alert(self.Locale.getString('noLinksInSelection'));
		return false;
	}
}

window.addEventListener("load", linkchecker.drweb.com.Startup, true);