(function(){
    settingsItem = function(id, name, type, pattern, block)
    {
        this.id = id;
        this.name = name;
        this.type= type;
        this.block= block;
        this.pattern = pattern;
    }
    //exception item - structure of database item
    exceptionItem = function(id, baseURL, allow)
    {
        this.id = id;
        this.baseURL = baseURL;
        this.allow= allow;
    }

    //exception item - structure of database item
    urlsItems = function(baseURL, block)
    {
        this.baseURL = baseURL;
        this.block = block;
    }

    var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                                    .getService(Components.interfaces.nsIPrefService).getBranch("extensions.linkchecker.");
    refreshSettings = function()
    {
        prefs = Components.classes["@mozilla.org/preferences-service;1"]
                                            .getService(Components.interfaces.nsIPrefService).getBranch("extensions.linkchecker.");
    }

    var locale = Components.classes["@mozilla.org/intl/stringbundle;1"]
                                    .getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://linkcheker/locale/linkchecker.properties");

    var analytics_enabled = "analytics-enabled";
    var social_enabled = "social-enabled";
    var track_enabled = "track-enabled";

    var flash_enabled = "flash-enabled";
    var ads_enabled = "ads-enabled";
    var blockParts = new Array();
    var urls = new Array();
    var adsExceptions = new Array();
    var flashExceptions = new Array();
    var urlsToRefresh = new Array();

    //initialize
	optionsInit = function()
	{
	    refreshSettings();
		Options = 
		{
			'vkontakte-check': 	true,
			'facebook-check': 	true,
			'google-check': 	true
		};

        uploadBlockedPartsItems();


		el('social-check').addEventListener('click', function() {setSocial(); setRefreshPageState();}, false);
		el('analytics-check').addEventListener('click', function() {setAnalytics(); setRefreshPageState();}, false);
		el('track-check').addEventListener('click', function() {setTrack(); setRefreshPageState();}, false);
        el('social-section').addEventListener('click', function() {setSocial(); setRefreshPageState();}, false);
        el('analytics-section').addEventListener('click', function() {setAnalytics(); setRefreshPageState();}, false);
        el('track-section').addEventListener('click', function() {setTrack(); setRefreshPageState();}, false);
        el('noprotection-check').addEventListener('click', function() {setNoProtection(); setRefreshPageState();}, false);
        el('noprotection-section').addEventListener('click', function() {setNoProtection(); setRefreshPageState();}, false);

        el('vkicon').addEventListener('click', function() {setSocialItem("vkontakte-check", "vkicon");}, false);
        el('facebookicon').addEventListener('click', function() {setSocialItem("facebook-check", "facebookicon");}, false);
        el('googleicon').addEventListener('click', function() {setSocialItem("google-check", "googleicon");}, false);

        el('updateDataBase').addEventListener('click', function() {updateDatabase();}, false);

        el('popupback').addEventListener('click', function(e) {
                                                               if (e.target.id == "popupback"){
                                                               el("adsExceptionTable").innerHTML = ""; el('siteURL2').value = ''; el("adsPopup").style.display="none";
                                                               el("flashExceptionTable").innerHTML = ""; el('siteURL').value = '';el("flashPopup").style.display="none";
                                                               el("popupback").style.display="none";
                                                               blockBackgroundScroll(false);}}, false);

        $('select[name="defaultFlashValue"]').change( function() {
            if ($(this).val() == "deny")
                prefs.setBoolPref("flash-enabled", true);
            else if ($(this).val() == "allow")
                prefs.setBoolPref("flash-enabled", false);
            setRefreshPageState();
        });

        $('select[name="defaultAdsValue"]').change( function() {
            if ($(this).val() == "deny")
                prefs.setBoolPref("ads-enabled", true);
            else if ($(this).val() == "allow")
                prefs.setBoolPref("ads-enabled", false);
            setRefreshPageState();
        });

        uploadLinkCheckerSettings();
        uploadTrackerSettings();
        uploadContentSettings();
        if (prefs.getCharPref("updateDate") != "")
            el("lastUpdateTime").innerHTML = prefs.getCharPref("updateDate");
        else el("lastUpdateTime").innerHTML = "-";
        if (prefs.getCharPref("version") != "")
            el("currentVersionNumber").innerHTML = prefs.getCharPref("version");
        else el("currentVersionNumber").innerHTML = "1.0";

        el('flashexception').addEventListener('click', function() {
           if (prefs.getCharPref("flashExceptions") != null && prefs.getCharPref("flashExceptions") != "")
           {
               flashExceptions = JSON.parse(prefs.getCharPref("flashExceptions"));
           }

            uploadException(flashExceptions, "flashExceptionTable", "flash");
            el("popupback").style.display="block";
            el("flashPopup").style.display="block";
            blockBackgroundScroll(true);
            $('.closePopup').bind("click", function() {
                 el("flashExceptionTable").innerHTML = "";
                 el("popupback").style.display="none";
                 el("flashPopup").style.display="none";
                 el('siteURL').value = '';
                 blockBackgroundScroll(false);
            });
            el('siteURL').focus();
        }, false);

        el('adsexception').addEventListener('click', function() {
           if (prefs.getCharPref("adsExceptions") != null &&
              prefs.getCharPref("adsExceptions") != "" &&
              prefs.getCharPref("adsExceptions") != "[]")
          {
              adsExceptions = JSON.parse(prefs.getCharPref("adsExceptions"));
          }
          for (var i =0; i<urls.length; i++)
           {
               var exist = false;
               var index = 0;
               for (var j=0; j <adsExceptions.length; j++)
               {
                  if (adsExceptions[j].baseURL == urls[i].baseURL)
                  {
                       index = j;
                       exist = true;
                       break;
                  }
               }
               if (!exist)
               {
                   var id = Math.random();
                   id = id.toString();
                   id = id.replace(".","");
                   id = "uni" + id;
                   adsExceptions.push(new exceptionItem(id, urls[i],false));
               }
               else adsExceptions[index].allow = !urls[i].block;
           }


           uploadException(adsExceptions, "adsExceptionTable", "ads");
           el("popupback").style.display="block";
           el("adsPopup").style.display="block";
           blockBackgroundScroll(true);
           $('.closePopup').bind("click", function() {
                el("adsExceptionTable").innerHTML = "";
                el("popupback").style.display="none";
                el("adsPopup").style.display="none";
                el('siteURL2').value = '';
                blockBackgroundScroll(false);
           });
           el('siteURL2').focus();
       }, false);
       localize();
	}

    //update database
    updateDatabase = function()
    {
         el('updateDataBase').style.display = "none";
         el('updating').style.display = "block";
         el('updatingImage').style.display = "block";

         var dateMark = prefs.getCharPref("updateDate");
         prefs.setBoolPref("updateDataBase", true);
         databaseUpdatedIntervalId = setInterval(function () {databaseUpdated(dateMark, databaseUpdatedIntervalId); }, 500);
    }

    databaseUpdated = function(datemark, databaseUpdatedIntervalId)
    {
          if (prefs.getBoolPref("updateDataBase") == false)
          {
             el('updateDataBase').style.display = "block";
             el('updating').style.display = "none";
             el('updatingImage').style.display = "none";

             el("lastUpdateTime").innerHTML = prefs.getCharPref("updateDate");
             el("currentVersionNumber").innerHTML = prefs.getCharPref("version");
             clearInterval(databaseUpdatedIntervalId);
          }
    }

    setRefreshPageState = function()
    {
        //prefs.setBoolPref("refresh", true);
    }

    setRefreshSpecialPageState = function(urls)
    {
        //prefs.setCharPref("refresh-special", JSON.stringify(urls));
    }

    blockBackgroundScroll = function(block)
    {
        if (block)
            window.document.body.style.overflow = "hidden";
        else window.document.body.style.overflow = "auto";
    }

    //upload settings for link checker
	uploadLinkCheckerSettings = function()
	{
	     var inputs = window.document.getElementById('options-form').getElementsByTagName('input');
	     for (var i = 0, l = inputs.length; i < l; i++)
         {
         	var key = inputs[i].name;

            if (prefs.getBoolPref(key))
                inputs[i].checked = true;
            else inputs[i].checked = false;

         	if (inputs[i].checked)
         	   inputs[i].parentNode.parentNode.children[0].setAttribute("selected", "true");
         	else inputs[i].parentNode.parentNode.children[0].setAttribute("selected", "false");
         	inputs[i].addEventListener('change', optionsSave, false);
         }
	}

    uploadBlockedPartsItems = function(){
        urls = new Array();
        if (prefs.getCharPref("blockedParts") != null &&
            prefs.getCharPref("blockedParts") != "" &&
            prefs.getCharPref("blockedParts") != undefined)
        {
            blockParts = JSON.parse(prefs.getCharPref("blockedParts"));
            for (var i =0; i<blockParts.length; i++)
            {
                var exist = false;
                for (var j=0; j <urls.length; j++)
                {
                    if (urls[j].baseURL == blockParts[i].baseURL)
                    {
                        exist = true;
                        break;
                    }
                }
                if (!exist)
                    urls.push(new urlsItems(blockParts[i].baseURL, blockParts[i].block));
            }
        }

    }

	//upload settings for tracker
	uploadTrackerSettings = function(){
        if (prefs.getBoolPref("social-enabled"))
        {
            setSocial();
            return;
        }

        if (prefs.getBoolPref("analytics-enabled"))
        {
            setAnalytics();
            return;
        }

        if (prefs.getBoolPref("track-enabled"))
        {
            setTrack();
            return;
        }

        setNoProtection();

    }

    setCounter = function(type)
    {
        if (type == "flash")
        {
            if (prefs.getCharPref("flashExceptions") != null && prefs.getCharPref("flashExceptions") != "")
            {
                flashExceptions = JSON.parse(prefs.getCharPref("flashExceptions"));
                el('flashExcCount').innerHTML = "(" + flashExceptions.length + ")";
            }
            else  el('flashExcCount').innerHTML = "(0)";
        }
        else
        {
             if (prefs.getCharPref("adsExceptions") != null && prefs.getCharPref("adsExceptions") != "")
             {
                 adsExceptions = JSON.parse(prefs.getCharPref("adsExceptions"));
                 for (var i =0; i<urls.length; i++)
                 {
                    var exist = false;
                    var index = 0;
                    for (var j=0; j <adsExceptions.length; j++)
                    {
                       if (adsExceptions[j].baseURL == urls[i].baseURL)
                       {
                            index = j;
                            exist = true;
                            break;
                       }
                    }
                    if (!exist)
                    {
                         var id = Math.random();
                         id = id.toString();
                         id = id.replace(".","");
                         id = "uni" + id;
                         adsExceptions.push(new exceptionItem(id, urls[i].baseURL, false));
                    }
                    else adsExceptions[index].allow = urls[i].block;
                 }
                 el('adsExcCount').innerHTML = "(" + adsExceptions.length + ")";
             }
             else  el('adsExcCount').innerHTML = "(0)";
        }
    }

    uploadContentSettings = function(){

        if (!prefs.getBoolPref("flash-enabled"))
            el("defaultFlashValue").options[0].selected = "selected";
        else
            el("defaultFlashValue").options[1].selected = "selected";

        if (!prefs.getBoolPref("ads-enabled"))
            el("defaultAdsValue").options[0].selected = "selected";
        else
            el("defaultAdsValue").options[1].selected = "selected";

        setCounter("flash");
        setCounter("ads");
    }

    uploadException = function(exceptions, tableId, type){
        urlsToRefresh = new Array();
        if (exceptions)
        {
            for (var i=0; i<exceptions.length; i++)
            {
                 appendExceptionItem(tableId, exceptions[i].allow, exceptions[i].id, exceptions[i].baseURL);
            }

            $('select[name="settings"]').change( function() {
                if ($(this).val() == "deny")
                    updateException($(this).attr("siteid"), type, false);
                else if ($(this).val() == "allow")
                    updateException($(this).attr("siteid"), type, true);
            });

            $('.removesite').bind("click", function() {
                removeException($(this).attr("siteid"), type);
                var elId = $(this).attr("siteid");
                $("#" + elId).remove();
            });

            var lng = locale.GetStringFromName("lng");
            if (type == "flash"){
                var objDiv = document.getElementById("scrollContainer1");
                $('#siteURL').bind('keypress', function(e) { if(e.keyCode==13){ addAddressEvent("flash", "siteURL", objDiv);} });
                $('#flashAddButton').bind('click', function(e) { addAddressEvent("flash", "siteURL", objDiv); });
                $('#readyButton').bind('click', function(e) {saveItems("flash"); hideFlashPopup(); hideAdsPopup()});
                if (lng == "en")
                {
                    el('flashSelect').style.marginLeft = "485px";
                }
            }
            else{
                var objDiv = document.getElementById("scrollContainer2");
                $('#siteURL2').bind('keypress', function(e) { if(e.keyCode==13){addAddressEvent("ads", "siteURL2", objDiv);}});
                $('#adsAddButton').bind('click', function(e) { addAddressEvent("ads", "siteURL2", objDiv); });
                $('#readyButton2').bind('click', function(e) {saveItems("ads"); hideFlashPopup(); hideAdsPopup();});
                if (lng == "en")
                {
                    el('adsSelect').style.marginLeft = "485px";
                }
            }

        }
    }

    function saveItems(type)
    {
         addAddressItem(type);
         if (type == "flash")
         {
            prefs.setCharPref("flashExceptions", JSON.stringify(flashExceptions));
            el('flashExcCount').innerHTML = "(" + flashExceptions.length + ")";
         }
         else if (type == "ads")
         {
            el("adsExceptionTable").innerHTML = "";
            prefs.setCharPref("adsExceptions", JSON.stringify(adsExceptions));
            prefs.setCharPref("blockedParts", JSON.stringify(blockParts));
            uploadBlockedPartsItems();
         }
         setCounter(type);
         if (urlsToRefresh.length != 0){
             setRefreshSpecialPageState(urlsToRefresh);
         }
    }

    //hide ads popup event handler
    function hideFlashPopup(){
        el("flashExceptionTable").innerHTML = "";
        el("popupback").style.display="none";
        el("flashPopup").style.display="none";
        el('siteURL').value = '';
        blockBackgroundScroll(false);
    }

    //hide flash popup event handler
    function hideAdsPopup(){
        el("adsExceptionTable").innerHTML = "";
        el("popupback").style.display="none";
        el("adsPopup").style.display="none";
        el('siteURL2').value = '';
        blockBackgroundScroll(false);
    }

    //create lines in a table
    function createTableLines(tableId)
    {
        var rows = document.getElementById(tableId).rows;
        for(var i = 0; i < rows.length; i++)
        {
           if(i%2==0){
              rows.item(i).style.backgroundColor = "#FFFFFF"
           }else{
              rows.item(i).style.backgroundColor = "#F2f2f2"
           }

        }
    }

    //add address event handler
    function addAddressEvent(type, input, objDiv)
    {
         addAddressItem(type);
         el(input).value = "";
         el(input).focus();
         //objDiv.scrollTop = objDiv.scrollHeight;
    }

    addAddressItem = function(type){
        if (type == "flash")
            var url = $('#siteURL').val().replace(/ /g,"");
        else
            var url = $('#siteURL2').val().replace(/ /g,"");
        url = url.replace(/["']/g, "");
        if (url != '') {
           var allow = true;

           if (type == "ads")
               $('select[name="addingAdsSiteUrlSelector"]').val() == "allow" ? allow = true : allow = false;
           else
               $('select[name="addingFlashSiteUrlSelector"]').val() == "allow" ? allow = true : allow = false;
           addException(url, type, allow);
           if (type == "ads"){
               el('siteURL2').value = '';
               el('siteURL2').focus();
           }
           else{
               el('siteURL').value = '';
               el('siteURL').focus();
           }
        }
    }

    //append item to table
    appendExceptionItem = function(tableId, allow, id, baseURL){
        var allow = (allow ? "selected" : "");
        var deny = (allow ? "" : "selected");
        var lng = locale.GetStringFromName("lng");
        var tr = 448;
        var div = "";
        if (lng == "ru")
        {
             tr = 417;
             div = "style='width:430px;'";

        }

        var html = "<tr class='addressItem' id='" +
                    id +
                    "'><td style='width:" +
                    tr +
                    "px;'><div class='siteurl' " +
                    div +
                    "><xmp>" +
                                          baseURL +
                                          "</xmp></div></td><td style='width: 60px; padding-left: 0px;'><div class='styled-select'><select siteId='"
                    + id + "' name='settings'><option value='allow' " +
                    + allow
                    + ">"
                    + locale.GetStringFromName("allowOption")
                    + "</option><option value='deny' "
                    + deny
                    + ">"
                    + locale.GetStringFromName("denyOption")
                    + "&nbsp;</option></select></div></td>"
                    + "<td class='sitebox'><div siteId='" + id
                    + "' class='removesite'></div>"
                    + "</td></tr>";
        $("#" + tableId).prepend(html);
        createTableLines(tableId);
    }

    encryptedString = function(string)
    {
         string = string.replace(/[<]/g, "&lt;");
         string = string.replace(/[>]/g, "&gt;");
         string = string.replace(/[&]/g, "&amp;");
         return string;
    }

    //adding site exception
    addException = function(url, type, allow){
        var id = Math.random();
        id = id.toString();
        id = id.replace(".","");
        id = "uni" + id;
        var baseURL = url.split( '/' )[2];
        if (!baseURL)
        {
            if (url.indexOf("www.") == -1)
                baseURL = "http://www." +  url;
            else baseURL = "http://" +  url;
            baseURL = baseURL.split( '/' )[2];
        }
        urlsToRefresh.push(baseURL);
        if (type == "flash")
        {
            var index = geExceptionByURL(flashExceptions, baseURL);
            if (index == null)
            {
                flashExceptions.push(new this.exceptionItem(this.id = id, this.baseURL = baseURL, this.allow = allow));
                appendExceptionItem("flashExceptionTable", allow, id, baseURL);
            }
            $('.removesite').bind("click", function() {
                removeException($(this).attr("siteid"), "flash");
                var elId = $(this).attr("siteid");
                $("#" + elId).remove();
                createTableLines("flashExceptionTable");
            });

        }
        else if (type == "ads")
        {
            var index = geExceptionByURL(adsExceptions, baseURL);
            if (index == null)
            {
                adsExceptions.push(new this.exceptionItem(this.id = id, this.baseURL = baseURL, this.allow= allow));
                appendExceptionItem("adsExceptionTable", allow, id, baseURL);
            }
            $('.removesite').bind("click", function() {
                removeException($(this).attr("siteid"), "ads");
                var elId = $(this).attr("siteid");
                $("#" + elId).remove();
                createTableLines("adsExceptionTable");
            });
        }


        $('select[name="settings"]').change( function() {
            if ($(this).val() == "deny")
                updateException($(this).attr("siteid"), "flash", false);
            else if ($(this).val() == "allow")
                updateException($(this).attr("siteid"), "flash", true);
        });


    }

    //removeException
    removeException = function(id, type)
    {
          refreshSettings();
          if (type == "flash")
          {
               var index = geExceptionById(flashExceptions, id);
               if (index != null)
               {
                  urlsToRefresh.push(flashExceptions[index].baseURL);
                  flashExceptions.splice(index, 1);
               }
          }
          else if (type == "ads")
          {
               var index = geExceptionById(adsExceptions, id);
               if (index != null)
               {
                  urlsToRefresh.push(adsExceptions[index].baseURL);
                  adsExceptions.splice(index, 1);
               }
               var sireURL = document.getElementById(id).children[0].textContent;
               var aLength = blockParts.length;
               for (var i =0; i<aLength; i++)
               {
                   if (blockParts[i].baseURL == sireURL)
                   {
                       urlsToRefresh.push(blockParts[i].baseURL);
                       blockParts.splice(i,1);
                       i--;
                       aLength--;
                   }
               }
          }
    }

    //update exception settings
    updateException = function(id, type, allow)
    {
         if (type == "flash")
         {
              var index = geExceptionById(flashExceptions, id);
              if (index != null)
              {
                 flashExceptions[index].allow = allow;
                 urlsToRefresh.push(flashExceptions[index].baseURL);
              }
         }
         else if (type == "ads")
         {
              var index = geExceptionById(adsExceptions, id);
              if (index != null)
              {
                 adsExceptions[index].allow = allow;
                 urlsToRefresh.push(adsExceptions[index].baseURL);
              }
              var sireURL = document.getElementById(id).children[0].textContent;
              aLength = blockParts.length;
              for (var i =0; i<aLength; i++)
              {
                  if (blockParts[i].baseURL == sireURL)
                  {
                        blockParts[i].block = !allow;
                        urlsToRefresh.push(blockParts[i].baseURL);
                  }
              }
         }
    }

    //getting exception by id
    geExceptionById = function(storage, id)
    {
         for (var i=0; i < storage.length; i++)
         {
            if (storage[i].id == id)
                return i;
         }
         return null;
    }

    //getting exception by id
    geUrlByExceptionId = function(storage, id)
    {
         for (var i=0; i < storage.length; i++)
         {
            if (storage[i].id == id)
                return storage.baseURL;
         }
         return null;
    }

     //getting exception by id
    geExceptionByURL = function(storage, url)
    {
         for (var i=0; i < storage.length; i++)
         {
            if (storage[i].baseURL == url)
                return i;
         }
         return null;
    }

    //set state for social checking
    setSocial = function()
    {
         prefs.setBoolPref("social-enabled", true);
         prefs.setBoolPref("analytics-enabled", true);
         prefs.setBoolPref("track-enabled", true);

         el('social-check').checked = true;
         el('social-section').setAttribute("selected", "true");
         el('analytics-section').setAttribute("selected", "false");
         el('track-section').setAttribute("selected", "false");
         el('noprotection-section').setAttribute("selected", "false");
    }

    //set state for web analytics checking
    setAnalytics = function()
    {
          prefs.setBoolPref("social-enabled", false);
          prefs.setBoolPref("analytics-enabled", true);
          prefs.setBoolPref("track-enabled", true);

          el('analytics-check').checked = true;
          el('analytics-section').setAttribute("selected", "true");
          el('social-section').setAttribute("selected", "false");
          el('track-section').setAttribute("selected", "false");
          el('noprotection-section').setAttribute("selected", "false");
    }

    //set state for ads checking
    setTrack = function()
    {
         prefs.setBoolPref("social-enabled", false);
         prefs.setBoolPref("analytics-enabled", false);
         prefs.setBoolPref("track-enabled", true);

         el('track-check').checked = true;
         el('track-section').setAttribute("selected", "true");
         el('social-section').setAttribute("selected", "false");
         el('analytics-section').setAttribute("selected", "false");
         el('noprotection-section').setAttribute("selected", "false");
    }

    setNoProtection = function()
    {
        prefs.setBoolPref("social-enabled", false);
        prefs.setBoolPref("analytics-enabled", false);
        prefs.setBoolPref("track-enabled", false);

         el('noprotection-check').checked = true;
         el('track-section').setAttribute("selected", "false");
         el('social-section').setAttribute("selected", "false");
         el('analytics-section').setAttribute("selected", "false");
         el('noprotection-section').setAttribute("selected", "true");
    }

    setAds = function()
    {
        if (el('enable-ads').checked)
            prefs.setBoolPref("ads-enabled", true);
        else prefs.setBoolPref("ads-enabled", false);
    }

    setFlash = function()
    {
        if (el('enable-flash').checked)
            prefs.setBoolPref("flash-enabled", true);
        else prefs.setBoolPref("flash-enabled", false);
    }

    //save link checker options
	optionsSave = function(eventObj)
	{
	    prefs.setBoolPref(eventObj.target.name, eventObj.target.checked?true:false);

		if (eventObj.target.checked)
            eventObj.target.parentNode.parentNode.children[0].setAttribute("selected", "true")
        else eventObj.target.parentNode.parentNode.children[0].setAttribute("selected", "false")

		return false;
	}

    //save vk check
	setSocialItem = function(checkbox, icon)
	{

	    if (el(checkbox).checked){
            el(checkbox).checked = false;
            el(icon).setAttribute("selected", "false");
        }
        else{
            el(checkbox).checked = true;
            el(icon).setAttribute("selected", "true");
        }
        prefs.setBoolPref(el(checkbox).name, el(checkbox).checked?true:false);
	}

    //save facebook check
    setFb = function()
    {
        if (el('facebook-check').checked)
            el('facebook-check').checked = false;
        else  el('facebook-check').checked = true;
        prefs.setCharPref("facebook-check", el('facebook-check').checked);
    }

    //save facebook check
    setGl = function()
    {
        if (el('google-check').checked)
            el('google-check').checked = false;
        else  el('google-check').checked = true;
        prefs.setCharPref("google-check", el('google-check').checked);
    }

    //localize document
    localize = function()
    {
         localizeObj("vkontakte-check-label", "vkontakteLabel");
         localizeObj("facebook-check-label", "facebookLabel");
         localizeObj("google-check-label", "googleLabel");
         localizeObj("description", "description");
         localizeObj("privacyPolicy", "privacyPolicy");
         localizeObj("otherSoftware", "otherSoftware");
         localizeObj("copyright", "copyright");

         localizeObj("autoCheckWebsites", "autoCheckWebsites");
         localizeObj("autoCheckWebsitesDesc", "autoCheckWebsitesDesc");
         localizeObj("internetTracker", "internetTracker");
         localizeObj("internetTrackerDesc", "internetTrackerDesc");
         localizeObj("allowAll", "allowAll");
         localizeObj("allowAllDesc", "allowAllDesc");
         localizeObj("minimal", "minimal");
         localizeObj("minimalDesc", "minimalDesc");
         localizeObj("medium", "medium");
         localizeObj("mediumDesc", "mediumDesc");
         localizeObj("maximum", "maximum");
         localizeObj("maximumDesc", "maximumDesc");
         localizeObj("pageContent", "pageContent");
         localizeObj("pageContentDesc", "pageContentDesc");
         localizeObj("flashPlugins", "flashPlugins");
         localizeObj("defaultAllow", "defaultAllow");
         localizeObj("defaultDeny", "defaultDeny");
         localizeObj("ads", "ads");
         localizeObj("defaultAllow2", "defaultAllow2");
         localizeObj("defaultDeny2", "defaultDeny2");

         localizeObj("flashExceptionHeader", "flashExceptionHeader");
         localizeObj("flashExceptionDesc", "flashExceptionDesc");
         localizeObj("flashAllow", "allowOption");
         localizeObj("flashDeny", "denyOption");

         localizeObj("adsExceptionHeader", "adsExceptionHeader");
         localizeObj("adsExceptionDesc", "adsExceptionDesc");
         localizeObj("adsAllow", "allowOption");
         localizeObj("adsDeny", "denyOption");

         localizeObj("flashExceptionString", "exception");
         localizeObj("adsExceptionString", "exception");

         localizeObj("readyButton", "readyButton");
         localizeObj("readyButton2", "readyButton");

         localizeObj("updateDataBase", "updateDataBase");
         localizeObj("lastUpdate", "lastUpdate");
         localizeObj("updating", "updating");
         localizeObj("currentVersion", "currentVersion");
         localizeObj("updateHeader", "updateHeader");
         localizeObj("updateDesc", "updateDesc");

    }

    //localize object
    localizeObj = function(objId, locId)
    {
         el(objId).textContent =  locale.GetStringFromName(locId);
    }

    //get element by ID
	el = function(id)
    {
        return window.document.getElementById(id);
    }
	
	window.addEventListener('DOMContentLoaded', optionsInit, false);
})();